/*****************************************************************************
  Digital Cameras RAW file support 
  Copyright (c) 2004 by Dmitry V. Fedorov <www.dimin.net> <dima@dimin.net>

  IMPLEMENTATION
  
  Programmer: Dima V. Fedorov <mailto:dima@dimin.net> <http://www.dimin.net/>

  History:
    10/26/2004 19:00 - First creation
        
  Ver : 1
*****************************************************************************/

#ifndef DIM_DCRAW_FORMAT_H
#define DIM_DCRAW_FORMAT_H

#include <DIVFormatDefs.h>
#include <DIVFormatUtils.h>

#include <stdio.h>

#define DCRAW_FORMAT_CANON    0
#define DCRAW_FORMAT_KODAK    1
#define DCRAW_FORMAT_MINOLTA  2
#define DCRAW_FORMAT_NIKON    3
#define DCRAW_FORMAT_OLYMPUS  4
#define DCRAW_FORMAT_PENTAX   5
#define DCRAW_FORMAT_FUJI     6
#define DCRAW_FORMAT_ROLLEI   7
#define DCRAW_FORMAT_SONY     8
#define DCRAW_FORMAT_SIGMA    9
#define DCRAW_FORMAT_DCRAW   10
#define DCRAW_FORMAT_DNG     11

DIM_INT          __stdcall dimDCRawValidateFormatProc ( void *magic, DIM_UINT32 length);
TDivFormatHandle __stdcall dimDCRawAquireFormatProc   ( void );
void             __stdcall dimDCRawReleaseFormatProc  ( TDivFormatHandle *fmtHndl);
DIM_UINT         __stdcall dimDCRawOpenImageProc      ( TDivFormatHandle *fmtHndl, TDIVIOModes io_mode);
void             __stdcall dimDCRawCloseImageProc     ( TDivFormatHandle *fmtHndl);
DIM_UINT         __stdcall dimDCRawGetNumPagesProc    ( TDivFormatHandle *fmtHndl );
TDivImageInfo    __stdcall dimDCRawGetImageInfoProc   ( TDivFormatHandle *fmtHndl, DIM_UINT page_num );
DIM_UINT         __stdcall dimDCRawAddMetaDataProc    ( TDivFormatHandle *fmtHndl);
DIM_UINT         __stdcall dimDCRawReadMetaDataProc   ( TDivFormatHandle *fmtHndl, DIM_UINT page, int group, int tag, int type);
char*            __stdcall dimDCRawReadMetaDataAsTextProc ( TDivFormatHandle *fmtHndl );
DIM_UINT         __stdcall dimDCRawReadImageProc      ( TDivFormatHandle *fmtHndl, DIM_UINT page );
DIM_UINT         __stdcall dimDCRawWriteImageProc     ( TDivFormatHandle *fmtHndl );
void             __stdcall dimDCRawConfigInitProc     ( TDivFormatHandle *fmtHndl, HWND hwndParent );
void             __stdcall dimDCRawConfigQuitProc     ( TDivFormatHandle *fmtHndl, HWND hwndParent );
DIM_UINT         __stdcall dimDCRawReadImageThumbProc (TDivFormatHandle *fmtHndl, DIM_UINT w, DIM_UINT h);


void             __stdcall dimDCRawLoadRegProc ( TDivFormatHandle *fmtHndl );
void             __stdcall dimDCRawSaveRegProc ( TDivFormatHandle *fmtHndl );

//----------------------------------------------------------------------------
// Internal Format Structs
//----------------------------------------------------------------------------

typedef struct TDimDCRawParams
{
  TDivImageInfo i;
  long num_images;
} TDimDCRawParams;
 

#endif // DIM_DCRAW_FORMAT_H
